#ifndef UDPSOCKET_H_
#define UDPSOCKET_H_

#ifdef WIN32
#include <Winsock2.h>
#else
#include <arpa/inet.h>
#endif

/**
 * Trieda UDPSocket umoznuje komunikaciu po sieti prostrednictvom protokolu UDP.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class UDPSocket
{
private:
#ifdef WIN32
	SOCKET fileDescriptor;
#else
	int fileDescriptor;
#endif
public:
	UDPSocket();
	bool setServer(unsigned short port, unsigned long address);
	bool send(char *sendingMessage);
	bool select(int seconds, int microseconds);
	bool receive(char *receivingMessage, int receivingMessageSize);
	virtual ~UDPSocket();
};

#endif /* UDPSOCKET_H_ */
