#ifndef EFFECTORSET_H_
#define EFFECTORSET_H_

#include "effectorset/Beam.h"
#include "effectorset/HingeJoint.h"
#include "effectorset/Say.h"

/**
 * Trieda EffectorSet umoznuje zlozit posielanu spravu, ktora bude obsahovat efektory.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class EffectorSet
{
private:
	int beamCount;
	Beam *beam;
	int hingeJointCount;
	HingeJoint *hingeJoint;
	int sayCount;
	Say *say;
public:
	EffectorSet();
	void setBeamCount(int beamCount);
	Beam *getBeam(int index);
	void setHingeJointCount(int hingeJointCount);
	HingeJoint *getHingeJoint(int index);
	void setSayCount(int sayCount);
	Say *getSay(int index);
	void compose(char *sendingMessage, int sendingMessageSize);
	virtual ~EffectorSet();
};

#endif /* EFFECTORSET_H_ */
