#ifndef PERCEPTORSET_H_
#define PERCEPTORSET_H_

#include "perceptorset/FRP.h"
#include "perceptorset/GS.h"
#include "perceptorset/GYR.h"
#include "perceptorset/Hear.h"
#include "perceptorset/HJ.h"
#include "perceptorset/See.h"
#include "perceptorset/Time.h"

/**
 * Trieda PerceptorSet umoznuje rozlozit prijatu spravu, ktora obsahuje perceptory.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class PerceptorSet
{
private:
	int hjCount;
	HJ *hj;
	int frpCount;
	FRP *frp;
	int gyrCount;
	GYR *gyr;
	Time *time;
	GS *gs;
	int seeCount;
	See *see;
	int hearCount;
	Hear *hear;
public:
	PerceptorSet();
	void decompose(char *receivingMessage);
	int getHJCount();
	HJ *getHJ(int index);
	int getFRPCount();
	FRP *getFRP(int index);
	int getGYRCount();
	GYR *getGYR(int index);
	Time *getTime();
	GS *getGS();
	int getSeeCount();
	See *getSee(int index);
	int getHearCount();
	Hear *getHear(int index);
	virtual ~PerceptorSet();
};

#endif /* PERCEPTORSET_H_ */
