#include "Me.h"
#include <math.h>
#include <string.h>

void Me::getPosition(float object0[3], float distanceFromObject0, float object1[3], float distanceFromObject1, float object2[3], float distanceFromObject2, float position0[2], float position1[2], float position2[2])
{
	float a = distanceFromObject0 * distanceFromObject0;
	float b[3] = {(a - object0[0] * object0[0] - object0[1] * object0[1] - object0[2] * object0[2]) / 2, (distanceFromObject1 * distanceFromObject1 - object1[0] * object1[0] - object1[1] * object1[1] - object1[2] * object1[2]) / 2, (distanceFromObject2 * distanceFromObject2 - object2[0] * object2[0] - object2[1] * object2[1] - object2[2] * object2[2]) / 2};
	float c[3][3] = {{object1[1] - object2[1], object2[1] - object0[1], object0[1] - object1[1]}, {object1[2] - object2[2], object2[2] - object0[2], object0[2] - object1[2]}, {object1[0] - object2[0], object2[0] - object0[0], object0[0] - object1[0]}};
	float d[3] = {object0[2] * c[0][0] + object1[2] * c[0][1] + object2[2] * c[0][2], object0[0] * c[1][0] + object1[0] * c[1][1] + object2[0] * c[1][2], object0[1] * c[2][0] + object1[1] * c[2][1] + object2[1] * c[2][2]};
	float e[3] = {object0[0] * c[1][0] + object1[0] * c[1][1] + object2[0] * c[1][2], object0[1] * c[2][0] + object1[1] * c[2][1] + object2[1] * c[2][2], object0[2] * c[0][0] + object1[2] * c[0][1] + object2[2] * c[0][2]};
	float f[3] = {b[0] * c[1][0] + b[1] * c[1][1] + b[2] * c[1][2], b[0] * c[2][0] + b[1] * c[2][1] + b[2] * c[2][2], b[0] * c[0][0] + b[1] * c[0][1] + b[2] * c[0][2]};
	float g0[3][2] = {{d[0], - object0[0] * d[0]}, {e[0], f[0] - object0[1] * d[0]}, {e[1], - f[2] - object0[2] * d[0]}};
	float a0 = g0[0][0] * g0[0][0] + g0[1][0] * g0[1][0] + g0[2][0] * g0[2][0];
	float b0 = (g0[0][0] * g0[0][1] + g0[1][0] * g0[1][1] + g0[2][0] * g0[2][1]) * 2;
	float c0 = g0[0][1] * g0[0][1] + g0[1][1] * g0[1][1] + g0[2][1] * g0[2][1] - a * d[0] * d[0];
	float d0 = b0 * b0 - 4 * a0 * c0;
	if (d0 < 0)
	{
		d0 = 0;
	}
	float e0 = sqrt(d0);
	float f0 = 2 * a0;
	position0[0] = (- b0 - e0) / f0;
	position0[1] = (- b0 + e0) / f0;
	float g1[3][2] = {{e[2], - f[0] - object0[0] * d[1]}, {d[1], - object0[1] * d[1]}, {e[1], f[1] - object0[2] * d[1]}};
	float a1 = g1[0][0] * g1[0][0] + g1[1][0] * g1[1][0] + g1[2][0] * g1[2][0];
	float b1 = (g1[0][0] * g1[0][1] + g1[1][0] * g1[1][1] + g1[2][0] * g1[2][1]) * 2;
	float c1 = g1[0][1] * g1[0][1] + g1[1][1] * g1[1][1] + g1[2][1] * g1[2][1] - a * d[1] * d[1];
	float d1 = b1 * b1 - 4 * a1 * c1;
	if (d1 < 0)
	{
		d1 = 0;
	}
	float e1 = sqrt(d1);
	float f1 = 2 * a1;
	position1[0] = (- b1 - e1) / f1;
	position1[1] = (- b1 + e1) / f1;
	float g2[3][2] = {{e[2], f[2] - object0[0] * d[2]}, {e[0], - f[1] - object0[1] * d[2]}, {d[2], - object0[2] * d[2]}};
	float a2 = g2[0][0] * g2[0][0] + g2[1][0] * g2[1][0] + g2[2][0] * g2[2][0];
	float b2 = (g2[0][0] * g2[0][1] + g2[1][0] * g2[1][1] + g2[2][0] * g2[2][1]) * 2;
	float c2 = g2[0][1] * g2[0][1] + g2[1][1] * g2[1][1] + g2[2][1] * g2[2][1] - a * d[2] * d[2];
	float d2 = b2 * b2 - 4 * a2 * c2;
	if (d2 < 0)
	{
		d2 = 0;
	}
	float e2 = sqrt(d2);
	float f2 = 2 * a2;
	position2[0] = (- b2 - e2) / f2;
	position2[1] = (- b2 + e2) / f2;
}

void Me::getObject(float distance, float angle1, float angle2, float object[3])
{
	float radAngle1 = angle1 / 57.295780181884765625f;
	float radAngle2 = angle2 / 57.295780181884765625f;
	float distance2 = cos(radAngle2) * distance;
	object[0] = cos(radAngle1) * distance2;
	object[1] = sin(radAngle1) * distance2;
	object[2] = sin(radAngle2) * distance;
}

void Me::getSolution(float a00, float a01, float a02, float b0, float a10, float a11, float a12, float b1, float a20, float a21, float a22, float b2, float solution[3])
{
	float c[3] = {a11 * a22 - a21 * a12, a02 * a21 - a22 * a01, a01 * a12 - a11 * a02};
	solution[0] = (b0 * c[0] + b1 * c[1] + b2 * c[2]) / (a00 * c[0] + a10 * c[1] + a20 * c[2]);
	float d[3] = {a12 * a20 - a22 * a10, a00 * a22 - a20 * a02, a02 * a10 - a12 * a00};
	solution[1] = (b0 * d[0] + b1 * d[1] + b2 * d[2]) / (a01 * d[0] + a11 * d[1] + a21 * d[2]);
	float e[3] = {a10 * a21 - a20 * a11, a01 * a20 - a21 * a00, a00 * a11 - a10 * a01};
	solution[2] = (b0 * e[0] + b1 * e[1] + b2 * e[2]) / (a02 * e[0] + a12 * e[1] + a22 * e[2]);
}

void Me::getRotationMatrix(float object00[3], float object01[3], float object10[3], float object11[3], float object20[3], float object21[3], float rotationMatrix[3][3])
{
	getSolution(object00[0], object00[1], object00[2], object01[0], object10[0], object10[1], object10[2], object11[0], object20[0], object20[1], object20[2], object21[0], rotationMatrix[0]);
	getSolution(object00[0], object00[1], object00[2], object01[1], object10[0], object10[1], object10[2], object11[1], object20[0], object20[1], object20[2], object21[1], rotationMatrix[1]);
	getSolution(object00[0], object00[1], object00[2], object01[2], object10[0], object10[1], object10[2], object11[2], object20[0], object20[1], object20[2], object21[2], rotationMatrix[2]);
}

/**
 * Konstruktor Me() inicializuje prvky a vytvori podtriedy, ktore budu potrebne na pracu so mnou (agentom).
 * @param team - Tim agenta.
 * @param id - Cislo agenta.
 * @param playGroundLength - Dlzka ihriska.
 * @param playGroundWidth - Sirka ihriska.
 * @param goalWidth - Sirka brany.
 * @param goalHeight - Vyska brany.
 * @param f1r - Pozicia F1R_pevneho objektu na ihrisku.
 * @param g1r - Pozicia G1R_pevneho objektu na ihrisku.
 * @param g2r - Pozicia G2R_pevneho objektu na ihrisku.
 * @param f2r - Pozicia F2R_pevneho objektu na ihrisku.
 * @param f2l - Pozicia F2L_pevneho objektu na ihrisku.
 * @param g2l - Pozicia G2L_pevneho objektu na ihrisku.
 * @param g1l - Pozicia G1L_pevneho objektu na ihrisku.
 * @param f1l - Pozicia F1L_pevneho objektu na ihrisku.
 */

Me::Me(char *team, int id, float playGroundLength, float playGroundWidth, float goalWidth, float goalHeight, float f1r[3], float g1r[3], float g2r[3], float f2r[3], float f2l[3], float g2l[3], float g1l[3], float f1l[3])
{
#ifdef WIN32
	strcpy_s(this->team, team);
#else
	strcpy(this->team, team);
#endif
	this->id = id;
	side[0] = '\0';
	this->playGroundLength = playGroundLength;
	this->playGroundWidth = playGroundWidth;
	this->goalWidth = goalWidth;
	this->goalHeight = goalHeight;
	this->f1r = f1r;
	this->g1r = g1r;
	this->g2r = g2r;
	this->f2r = f2r;
	this->f2l = f2l;
	this->g2l = g2l;
	this->g1l = g1l;
	this->f1l = f1l;
	position[0] = 340282346638528860000000000000000000000.0f;
	position[1] = 340282346638528860000000000000000000000.0f;
	position[2] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[0][0] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[0][1] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[0][2] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[1][0] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[1][1] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[1][2] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[2][0] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[2][1] = 340282346638528860000000000000000000000.0f;
	rotationMatrix[2][2] = 340282346638528860000000000000000000000.0f;
	beam[0] = 340282346638528860000000000000000000000.0f;
	beam[1] = 340282346638528860000000000000000000000.0f;
	beam[2] = 340282346638528860000000000000000000000.0f;
	beamChanged = false;
	hingeJoint2 = new HingeJoint2[22]();
	forceResistance2Count = 0;
	forceResistance2 = new ForceResistance2[2]();
	hear2Count = 0;
	hear2 = new Hear2[22]();
	say[0] = '\0';
	sayChanged = false;
	nextState = new NextState();
}

/**
 * Metoda transform() transformuje data zo sady perceptorov.
 * @param perceptorSet - Ukazovatel na sadu perceptorov, z ktorej sa transformuju data.
 */

void Me::transform(PerceptorSet *perceptorSet)
{
	GS *gs = perceptorSet->getGS();
	if (gs->getUnumCount() > 0)
	{
		id = gs->getUnum(0)->getId();
	}
	if (gs->getTeamCount() > 0)
	{
#ifdef WIN32
		strcpy_s(side, gs->getTeam(0)->getSide());
#else
		strcpy(side, gs->getTeam(0)->getSide());
#endif
		float a1 = playGroundLength / 2;
		float a2 = - a1;
		float a3 = playGroundWidth / 2;
		float a4 = - a3;
		float a5 = goalWidth / 2;
		float a6 = - a5;
		float a7 = 0;
		float a8 = a7 + goalHeight;
		if (strcmp(side, "left") == 0)
		{
			f1r[0] = a1;
			f1r[1] = a3;
			f1r[2] = a7;
			g1r[0] = a1;
			g1r[1] = a5;
			g1r[2] = a8;
			g2r[0] = a1;
			g2r[1] = a6;
			g2r[2] = a8;
			f2r[0] = a1;
			f2r[1] = a4;
			f2r[2] = a7;
			f2l[0] = a2;
			f2l[1] = a4;
			f2l[2] = a7;
			g2l[0] = a2;
			g2l[1] = a6;
			g2l[2] = a8;
			g1l[0] = a2;
			g1l[1] = a5;
			g1l[2] = a8;
			f1l[0] = a2;
			f1l[1] = a3;
			f1l[2] = a7;
		}
		else if (strcmp(side, "right") == 0)
		{
			f1r[0] = a2;
			f1r[1] = a4;
			f1r[2] = a7;
			g1r[0] = a2;
			g1r[1] = a6;
			g1r[2] = a8;
			g2r[0] = a2;
			g2r[1] = a5;
			g2r[2] = a8;
			f2r[0] = a2;
			f2r[1] = a3;
			f2r[2] = a7;
			f2l[0] = a1;
			f2l[1] = a3;
			f2l[2] = a7;
			g2l[0] = a1;
			g2l[1] = a5;
			g2l[2] = a8;
			g1l[0] = a1;
			g1l[1] = a6;
			g1l[2] = a8;
			f1l[0] = a1;
			f1l[1] = a4;
			f1l[2] = a7;
		}
	}
	if (perceptorSet->getSeeCount() > 0)
	{
		See *see = perceptorSet->getSee(0);
		if (see->getF1RCount() > 0 && see->getG1RCount() > 0 && see->getG2RCount() > 0 && see->getF2RCount() > 0)
		{
			Pol *f1rPol = see->getF1R(0)->getPol();
			Pol *g1rPol = see->getG1R(0)->getPol();
			Pol *g2rPol = see->getG2R(0)->getPol();
			Pol *f2rPol = see->getF2R(0)->getPol();
			float f1rDistance = f1rPol->getDistance();
			float g1rDistance = g1rPol->getDistance();
			float g2rDistance = g2rPol->getDistance();
			float f2rDistance = f2rPol->getDistance();
			float position0[2];
			float position1[2];
			float position2[2];
			if (strcmp(side, "left") == 0)
			{
				getPosition(f1r, f1rDistance, g1r, g1rDistance, g2r, g2rDistance, position0, position1, position2);
				position[0] = position0[0];
				position[1] = position1[0];
				position[2] = position2[0];
				getPosition(f1r, f1rDistance, g1r, g1rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
				getPosition(f1r, f1rDistance, g2r, g2rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
				getPosition(g1r, g1rDistance, g2r, g2rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
			}
			else if (strcmp(side, "right") == 0)
			{
				getPosition(f1r, f1rDistance, g1r, g1rDistance, g2r, g2rDistance, position0, position1, position2);
				position[0] = position0[1];
				position[1] = position1[1];
				position[2] = position2[1];
				getPosition(f1r, f1rDistance, g1r, g1rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
				getPosition(f1r, f1rDistance, g2r, g2rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
				getPosition(g1r, g1rDistance, g2r, g2rDistance, f2r, f2rDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
			}
			position[0] /= 4;
			position[1] /= 4;
			position[2] /= 4;
			float f1r0[3];
			getObject(f1rDistance, f1rPol->getAngle1(), f1rPol->getAngle2(), f1r0);
			float f1r1[3] = {f1r[0] - position[0], f1r[1] - position[1], f1r[2] - position[2]};
			float g1r0[3];
			getObject(g1rDistance, g1rPol->getAngle1(), g1rPol->getAngle2(), g1r0);
			float g1r1[3] = {g1r[0] - position[0], g1r[1] - position[1], g1r[2] - position[2]};
			float g2r0[3];
			getObject(g2rDistance, g2rPol->getAngle1(), g2rPol->getAngle2(), g2r0);
			float g2r1[3] = {g2r[0] - position[0], g2r[1] - position[1], g2r[2] - position[2]};
			float f2r0[3];
			getObject(f2rDistance, f2rPol->getAngle1(), f2rPol->getAngle2(), f2r0);
			float f2r1[3] = {f2r[0] - position[0], f2r[1] - position[1], f2r[2] - position[2]};
			getRotationMatrix(f1r0, f1r1, g1r0, g1r1, g2r0, g2r1, rotationMatrix);
			float rotationMatrix0[3][3];
			getRotationMatrix(f1r0, f1r1, g1r0, g1r1, f2r0, f2r1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			getRotationMatrix(f1r0, f1r1, g2r0, g2r1, f2r0, f2r1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			getRotationMatrix(g1r0, g1r1, g2r0, g2r1, f2r0, f2r1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			rotationMatrix[0][0] /= 4;
			rotationMatrix[0][1] /= 4;
			rotationMatrix[0][2] /= 4;
			rotationMatrix[1][0] /= 4;
			rotationMatrix[1][1] /= 4;
			rotationMatrix[1][2] /= 4;
			rotationMatrix[2][0] /= 4;
			rotationMatrix[2][1] /= 4;
			rotationMatrix[2][2] /= 4;
		}
		else if (see->getF2LCount() > 0 && see->getG2LCount() > 0 && see->getG1LCount() > 0 && see->getF1LCount() > 0)
		{
			Pol *f2lPol = see->getF2L(0)->getPol();
			Pol *g2lPol = see->getG2L(0)->getPol();
			Pol *g1lPol = see->getG1L(0)->getPol();
			Pol *f1lPol = see->getF1L(0)->getPol();
			float f2lDistance = f2lPol->getDistance();
			float g2lDistance = g2lPol->getDistance();
			float g1lDistance = g1lPol->getDistance();
			float f1lDistance = f1lPol->getDistance();
			float position0[2];
			float position1[2];
			float position2[2];
			if (strcmp(side, "left") == 0)
			{
				getPosition(f2l, f2lDistance, g2l, g2lDistance, g1l, g1lDistance, position0, position1, position2);
				position[0] = position0[1];
				position[1] = position1[1];
				position[2] = position2[1];
				getPosition(f2l, f2lDistance, g2l, g2lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
				getPosition(f2l, f2lDistance, g1l, g1lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
				getPosition(g2l, g2lDistance, g1l, g1lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[1];
				position[1] += position1[1];
				position[2] += position2[1];
			}
			else if (strcmp(side, "right") == 0)
			{
				getPosition(f2l, f2lDistance, g2l, g2lDistance, g1l, g1lDistance, position0, position1, position2);
				position[0] = position0[0];
				position[1] = position1[0];
				position[2] = position2[0];
				getPosition(f2l, f2lDistance, g2l, g2lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
				getPosition(f2l, f2lDistance, g1l, g1lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
				getPosition(g2l, g2lDistance, g1l, g1lDistance, f1l, f1lDistance, position0, position1, position2);
				position[0] += position0[0];
				position[1] += position1[0];
				position[2] += position2[0];
			}
			position[0] /= 4;
			position[1] /= 4;
			position[2] /= 4;
			float f2l0[3];
			getObject(f2lDistance, f2lPol->getAngle1(), f2lPol->getAngle2(), f2l0);
			float f2l1[3] = {f2l[0] - position[0], f2l[1] - position[1], f2l[2] - position[2]};
			float g2l0[3];
			getObject(g2lDistance, g2lPol->getAngle1(), g2lPol->getAngle2(), g2l0);
			float g2l1[3] = {g2l[0] - position[0], g2l[1] - position[1], g2l[2] - position[2]};
			float g1l0[3];
			getObject(g1lDistance, g1lPol->getAngle1(), g1lPol->getAngle2(), g1l0);
			float g1l1[3] = {g1l[0] - position[0], g1l[1] - position[1], g1l[2] - position[2]};
			float f1l0[3];
			getObject(f1lDistance, f1lPol->getAngle1(), f1lPol->getAngle2(), f1l0);
			float f1l1[3] = {f1l[0] - position[0], f1l[1] - position[1], f1l[2] - position[2]};
			getRotationMatrix(f2l0, f2l1, g2l0, g2l1, g1l0, g1l1, rotationMatrix);
			float rotationMatrix0[3][3];
			getRotationMatrix(f2l0, f2l1, g2l0, g2l1, f1l0, f1l1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			getRotationMatrix(f2l0, f2l1, g1l0, g1l1, f1l0, f1l1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			getRotationMatrix(g2l0, g2l1, g1l0, g1l1, f1l0, f1l1, rotationMatrix0);
			rotationMatrix[0][0] += rotationMatrix0[0][0];
			rotationMatrix[0][1] += rotationMatrix0[0][1];
			rotationMatrix[0][2] += rotationMatrix0[0][2];
			rotationMatrix[1][0] += rotationMatrix0[1][0];
			rotationMatrix[1][1] += rotationMatrix0[1][1];
			rotationMatrix[1][2] += rotationMatrix0[1][2];
			rotationMatrix[2][0] += rotationMatrix0[2][0];
			rotationMatrix[2][1] += rotationMatrix0[2][1];
			rotationMatrix[2][2] += rotationMatrix0[2][2];
			rotationMatrix[0][0] /= 4;
			rotationMatrix[0][1] /= 4;
			rotationMatrix[0][2] /= 4;
			rotationMatrix[1][0] /= 4;
			rotationMatrix[1][1] /= 4;
			rotationMatrix[1][2] /= 4;
			rotationMatrix[2][0] /= 4;
			rotationMatrix[2][1] /= 4;
			rotationMatrix[2][2] /= 4;
		}
		else
		{
			position[0] = 340282346638528860000000000000000000000.0f;
			position[1] = 340282346638528860000000000000000000000.0f;
			position[2] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[0][0] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[0][1] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[0][2] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[1][0] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[1][1] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[1][2] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[2][0] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[2][1] = 340282346638528860000000000000000000000.0f;
			rotationMatrix[2][2] = 340282346638528860000000000000000000000.0f;
		}
	}
	for (int i = 0; i < perceptorSet->getHJCount(); i ++)
	{
		HJ *hj = perceptorSet->getHJ(i);
		char *name = hj->getN()->getName();
		if (strcmp(name, "hj1") == 0)
		{
			hingeJoint2[HEAD1].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "hj2") == 0)
		{
			hingeJoint2[HEAD2].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "raj1") == 0)
		{
			hingeJoint2[RIGHTARM1].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "raj2") == 0)
		{
			hingeJoint2[RIGHTARM2].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "raj3") == 0)
		{
			hingeJoint2[RIGHTARM3].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "raj4") == 0)
		{
			hingeJoint2[RIGHTARM4].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj1") == 0)
		{
			hingeJoint2[RIGHTLEG1].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj2") == 0)
		{
			hingeJoint2[RIGHTLEG2].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj3") == 0)
		{
			hingeJoint2[RIGHTLEG3].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj4") == 0)
		{
			hingeJoint2[RIGHTLEG4].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj5") == 0)
		{
			hingeJoint2[RIGHTLEG5].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "rlj6") == 0)
		{
			hingeJoint2[RIGHTLEG6].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "laj1") == 0)
		{
			hingeJoint2[LEFTARM1].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "laj2") == 0)
		{
			hingeJoint2[LEFTARM2].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "laj3") == 0)
		{
			hingeJoint2[LEFTARM3].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "laj4") == 0)
		{
			hingeJoint2[LEFTARM4].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj1") == 0)
		{
			hingeJoint2[LEFTLEG1].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj2") == 0)
		{
			hingeJoint2[LEFTLEG2].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj3") == 0)
		{
			hingeJoint2[LEFTLEG3].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj4") == 0)
		{
			hingeJoint2[LEFTLEG4].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj5") == 0)
		{
			hingeJoint2[LEFTLEG5].setAngle(hj->getAx()->getAngle());
		}
		else if (strcmp(name, "llj6") == 0)
		{
			hingeJoint2[LEFTLEG6].setAngle(hj->getAx()->getAngle());
		}
	}
	forceResistance2Count = perceptorSet->getFRPCount();
	for (int i = 0; i < forceResistance2Count; i ++)
	{
		FRP *frp = perceptorSet->getFRP(i);
		C *c = frp->getC();
		F *f = frp->getF();
		forceResistance2[i].setNameAndCAndF(frp->getN()->getName(), c->getX(), c->getY(), c->getZ(), f->getX(), f->getY(), f->getZ());
	}
	hear2Count = perceptorSet->getHearCount();
	for (int i = 0; i < hear2Count; i ++)
	{
		Hear *hear = perceptorSet->getHear(i);
		hear2[i].setDirectionAndMessage(hear->getDirection(), hear->getMessage());
	}
}

/**
 * Metoda reverseTransform() spatne transformuje data do sady efektorov.
 * @param effectorSet - Ukazovatel na sadu efektorov, do ktorej sa spatne transformuju data.
 */

void Me::reverseTransform(EffectorSet *effectorSet)
{
	if (beamChanged)
	{
		effectorSet->getBeam(0)->set(beam[0], beam[1], beam[2]);
		beamChanged = false;
		effectorSet->setBeamCount(1);
	}
	int hingeJoint2Count = 0;
	if (hingeJoint2[HEAD1].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "he1", hingeJoint2[HEAD1].getAngularVelocity());
		hingeJoint2[HEAD1].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[HEAD2].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "he2", hingeJoint2[HEAD2].getAngularVelocity());
		hingeJoint2[HEAD2].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTARM1].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rae1", hingeJoint2[RIGHTARM1].getAngularVelocity());
		hingeJoint2[RIGHTARM1].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTARM2].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rae2", hingeJoint2[RIGHTARM2].getAngularVelocity());
		hingeJoint2[RIGHTARM2].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTARM3].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rae3", hingeJoint2[RIGHTARM3].getAngularVelocity());
		hingeJoint2[RIGHTARM3].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTARM4].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rae4", hingeJoint2[RIGHTARM4].getAngularVelocity());
		hingeJoint2[RIGHTARM4].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG1].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle1", hingeJoint2[RIGHTLEG1].getAngularVelocity());
		hingeJoint2[RIGHTLEG1].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG2].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle2", hingeJoint2[RIGHTLEG2].getAngularVelocity());
		hingeJoint2[RIGHTLEG2].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG3].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle3", hingeJoint2[RIGHTLEG3].getAngularVelocity());
		hingeJoint2[RIGHTLEG3].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG4].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle4", hingeJoint2[RIGHTLEG4].getAngularVelocity());
		hingeJoint2[RIGHTLEG4].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG5].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle5", hingeJoint2[RIGHTLEG5].getAngularVelocity());
		hingeJoint2[RIGHTLEG5].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[RIGHTLEG6].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "rle6", hingeJoint2[RIGHTLEG6].getAngularVelocity());
		hingeJoint2[RIGHTLEG6].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTARM1].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lae1", hingeJoint2[LEFTARM1].getAngularVelocity());
		hingeJoint2[LEFTARM1].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTARM2].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lae2", hingeJoint2[LEFTARM2].getAngularVelocity());
		hingeJoint2[LEFTARM2].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTARM3].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lae3", hingeJoint2[LEFTARM3].getAngularVelocity());
		hingeJoint2[LEFTARM3].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTARM4].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lae4", hingeJoint2[LEFTARM4].getAngularVelocity());
		hingeJoint2[LEFTARM4].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG1].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle1", hingeJoint2[LEFTLEG1].getAngularVelocity());
		hingeJoint2[LEFTLEG1].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG2].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle2", hingeJoint2[LEFTLEG2].getAngularVelocity());
		hingeJoint2[LEFTLEG2].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG3].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle3", hingeJoint2[LEFTLEG3].getAngularVelocity());
		hingeJoint2[LEFTLEG3].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG4].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle4", hingeJoint2[LEFTLEG4].getAngularVelocity());
		hingeJoint2[LEFTLEG4].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG5].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle5", hingeJoint2[LEFTLEG5].getAngularVelocity());
		hingeJoint2[LEFTLEG5].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	if (hingeJoint2[LEFTLEG6].getAngularVelocityChanged())
	{
		effectorSet->getHingeJoint(hingeJoint2Count)->set((char *) "lle6", hingeJoint2[LEFTLEG6].getAngularVelocity());
		hingeJoint2[LEFTLEG6].resetAngularVelocityChanged();
		hingeJoint2Count ++;
	}
	effectorSet->setHingeJointCount(hingeJoint2Count);
	if (sayChanged)
	{
		effectorSet->getSay(0)->set(say);
		sayChanged = false;
		effectorSet->setSayCount(1);
	}
}

/**
 * Metoda getTeam() vrati tim agenta.
 * @return Tim agenta.
 */

char *Me::getTeam()
{
	return team;
}

/**
 * Metoda getId() vrati cislo agenta.
 * @return Cislo agenta.
 */

int Me::getId()
{
	return id;
}

/**
 * Metoda getSide() vrati stranu agenta.
 * @return Strana agenta.
 */

char *Me::getSide()
{
	return side;
}

/**
 * Metoda getPosition() vrati poziciu agenta na ihrisku.
 * @return Pozicia agenta na ihrisku (Ukazovatel na jednorozmerne pole s 3 hodnotami - suradnicami agenta na ihrisku). Ak pozicia agenta na ihrisku nie je znama, tak sa vrati ukazovatel na jednorozmerne pole s 3 hodnotami 340282346638528860000000000000000000000.0f - co znamena neznamu poziciu agenta na ihrisku.
 */

float *Me::getPosition()
{
	return position;
}

/**
 * Metoda getRotationMatrix() vrati rotacnu maticu agenta na ihrisku.
 * @return Rotacna matica agenta na ihrisku. Ak rotacna matica agenta na ihrisku nie je znama, tak sa vrati rotacna matica s hodnotami 340282346638528860000000000000000000000.0f - co znamena neznamu rotacnu maticu agenta na ihrisku.
 */

float (*Me::getRotationMatrix())[3]
{
	return rotationMatrix;
}

/**
 * Metoda setPositionAndRotation() nastavi poziciu agenta na ihrisku a uhol natocenia agenta na ihrisku v rovine XY.
 * @param x - X-ova suradnica agenta na ihrisku.
 * @param y - Y-ova suradnica agenta na ihrisku.
 * @param rotation - Uhol natocenia agenta na ihrisku v rovine XY.
 */

void Me::setPositionAndRotation(float x, float y, float rotation)
{
	beam[0] = x;
	beam[1] = y;
	beam[2] = rotation;
	beamChanged = true;
}

/**
 * Metoda getHingeJoint2() vrati ukazovatel na pozadovany pantovy klb agenta.
 * @param index - Cislo pozadovaneho pantoveho klbu agenta. Moze nadobudat hodnoty:
 * <ul>
 * 	<li>HEAD1</li>
 * 	<li>HEAD2</li>
 * 	<li>RIGHTARM1</li>
 * 	<li>RIGHTARM2</li>
 * 	<li>RIGHTARM3</li>
 * 	<li>RIGHTARM4</li>
 * 	<li>RIGHTLEG1</li>
 * 	<li>RIGHTLEG2</li>
 * 	<li>RIGHTLEG3</li>
 * 	<li>RIGHTLEG4</li>
 * 	<li>RIGHTLEG5</li>
 * 	<li>RIGHTLEG6</li>
 * 	<li>LEFTARM1</li>
 * 	<li>LEFTARM2</li>
 * 	<li>LEFTARM3</li>
 * 	<li>LEFTARM4</li>
 * 	<li>LEFTLEG1</li>
 * 	<li>LEFTLEG2</li>
 * 	<li>LEFTLEG3</li>
 * 	<li>LEFTLEG4</li>
 * 	<li>LEFTLEG5</li>
 * 	<li>LEFTLEG6</li>
 * </ul>
 * @return Ukazovatel na pozadovany pantovy klb agenta.
 */

HingeJoint2 *Me::getHingeJoint2(int index)
{
	return &hingeJoint2[index];
}

/**
 * Metoda getForceResistance2Count() vrati pocet odporovych sil casti tela agenta.
 * @return Pocet odporovych sil casti tela agenta.
 */

int Me::getForceResistance2Count()
{
	return forceResistance2Count;
}

/**
 * Metoda getForceResistance2() vrati ukazovatel na pozadovanu odporovu silu casti tela agenta.
 * @param index - Cislo pozadovanej odporovej sily casti tela agenta.
 * @return Ukazovatel na pozadovanu odporovu silu casti tela agenta.
 */

ForceResistance2 *Me::getForceResistance2(int index)
{
	return &forceResistance2[index];
}

/**
 * Metoda getHear2Count() vrati pocet pocutych sprav agenta.
 * @return Pocet pocutych sprav agenta.
 */

int Me::getHear2Count()
{
	return hear2Count;
}

/**
 * Metoda getHear2() vrati ukazovatel na pozadovanu pocutu spravu agenta.
 * @param index - Cislo pozadovanej pocutej spravy agenta.
 * @return Ukazovatel na pozadovanu pocutu spravu agenta.
 */

Hear2 *Me::getHear2(int index)
{
	return &hear2[index];
}

/**
 * Metoda setSay() nastavi spravu, ktoru ma agent povedat.
 * @param message - Sprava, ktoru ma agent povedat.
 */

void Me::setSay(char *message)
{
#ifdef WIN32
	strcpy_s(say, message);
#else
	strcpy(say, message);
#endif
	sayChanged = true;
}

/**
 * Metoda getNextState() vrati ukazovatel na nasledujuci stav agenta.
 * @return Ukazovatel na nasledujuci stav agenta.
 */

NextState *Me::getNextState()
{
	return nextState;
}

/**
 * Destruktor ~Me() zrusi podtriedy, ktore boli potrebne na pracu so mnou (agentom).
 */

Me::~Me()
{
	delete nextState;
	delete[] hear2;
	delete[] forceResistance2;
	delete[] hingeJoint2;
}
