#include "ForceResistance2.h"
#include <string.h>

/**
 * Konstruktor ForceResistance2() inicializuje prvky, ktore budu potrebne na pracu s odporovou silou casti tela agenta.
 */

ForceResistance2::ForceResistance2()
{
	name[0] = '\0';
	c[0] = 0;
	c[1] = 0;
	c[2] = 0;
	f[0] = 0;
	f[1] = 0;
	f[2] = 0;
}

/**
 * Metoda setNameAndCAndF() nastavi nazov, poziciu casti tela agenta odkial odporova sila posobi a odporovu silu casti tela agenta.
 * @param name - Nazov casti tela agenta odkial odporova sila posobi.
 * @param cx - X-ova suradnica casti tela agenta odkial odporova sila posobi.
 * @param cy - Y-ova suradnica casti tela agenta odkial odporova sila posobi.
 * @param cz - Z-ova suradnica casti tela agenta odkial odporova sila posobi.
 * @param fx - X-ova zlozka odporovej sily casti tela agenta.
 * @param fy - Y-ova zlozka odporovej sily casti tela agenta.
 * @param fz - Z-ova zlozka odporovej sily casti tela agenta.
 */

void ForceResistance2::setNameAndCAndF(char *name, float cx, float cy, float cz, float fx, float fy, float fz)
{
#ifdef WIN32
	strcpy_s(this->name, name);
#else
	strcpy(this->name, name);
#endif
	c[0] = cx;
	c[1] = cy;
	c[2] = cz;
	f[0] = fx;
	f[1] = fy;
	f[2] = fz;
}

/**
 * Metoda getName() vrati nazov casti tela agenta odkial odporova sila posobi.
 * @return Nazov casti tela agenta odkial odporova sila posobi.
 */

char *ForceResistance2::getName()
{
	return name;
}

/**
 * Metoda getC() vrati poziciu casti tela agenta odkial odporova sila posobi.
 * @return Pozicia casti tela agenta odkial odporova sila posobi (Ukazovatel na jednorozmerne pole s 3 hodnotami - suradnicami casti tela agenta odkial odporova sila posobi).
 */

float *ForceResistance2::getC()
{
	return c;
}

/**
 * Metoda getF() vrati odporovu silu casti tela agenta.
 * @return Odporova sila casti tela agenta (Ukazovatel na jednorozmerne pole s 3 hodnotami - zlozkami odporovej sily casti tela agenta).
 */

float *ForceResistance2::getF()
{
	return f;
}
