#include "HingeJoint2.h"

/**
 * Konstruktor HingeJoint2() inicializuje prvky, ktore budu potrebne na pracu s pantovym klbom agenta.
 */

HingeJoint2::HingeJoint2()
{
	angle = 0;
	angularVelocity = 0;
	angularVelocityChanged = false;
}

/**
 * Metoda setAngle() nastavi uhol pantoveho klbu agenta.
 * @param angle - Uhol pantoveho klbu agenta.
 */

void HingeJoint2::setAngle(float angle)
{
	this->angle = angle;
}

/**
 * Metoda getAngle() vrati uhol pantoveho klbu agenta.
 * @return Uhol pantoveho klbu agenta.
 */

float HingeJoint2::getAngle()
{
	return angle;
}

/**
 * Metoda setAngularVelocity() nastavi uhlovu rychlost pantoveho klbu agenta.
 * @param angularVelocity - Uhlova rychlost pantoveho klbu agenta.
 */

void HingeJoint2::setAngularVelocity(float angularVelocity)
{
	this->angularVelocity = angularVelocity;
	angularVelocityChanged = true;
}

/**
 * Metoda getAngularVelocity() vrati uhlovu rychlost pantoveho klbu agenta.
 * @return Uhlova rychlost pantoveho klbu agenta.
 */

float HingeJoint2::getAngularVelocity()
{
	return angularVelocity;
}

/**
 * Metoda resetAngularVelocityChanged() resetuje zmenu uhlovej rychlosti pantoveho klbu agenta.
 */

void HingeJoint2::resetAngularVelocityChanged()
{
	angularVelocityChanged = false;
}

/**
 * Metoda getAngularVelocityChanged() vrati zmenu uhlovej rychlosti pantoveho klbu agenta.
 * @return Zmena uhlovej rychlosti pantoveho klbu agenta.
 */

bool HingeJoint2::getAngularVelocityChanged()
{
	return angularVelocityChanged;
}
