#include "Say.h"
#include <stdio.h>
#include <string.h>

/**
 * Konstruktor Say() inicializuje prvok, ktory bude potrebny na zlozenie casti posielanej spravy, ktora bude obsahovat say efektor.
 */

Say::Say()
{
	message[0] = '\0';
}

/**
 * Metoda set() nastavi prvok, ktory bude potrebny na zlozenie casti posielanej spravy, ktora bude obsahovat say efektor.
 * @param message - Sprava, ktoru agent povie.
 */

void Say::set(char *message)
{
#ifdef WIN32
	strcpy_s(this->message, message);
#else
	strcpy(this->message, message);
#endif
}

/**
 * Metoda compose() zlozi z prvku cast posielanej spravy, ktora bude obsahovat say efektor.
 * @param sendingMessage - Vystupna cast posielanej spravy, ktora bude obsahovat say efektor.
 * @param sendingMessageSize - Maximalna dlzka casti posielanej spravy, ktora bude obsahovat say efektor.
 * @return Dlzka casti posielanej spravy, ktora bude obsahovat say efektor.
 */

int Say::compose(char *sendingMessage, int sendingMessageSize)
{
#ifdef WIN32
	return sprintf_s(sendingMessage, sendingMessageSize, "(say %s)", message);
#else
	return sprintf(sendingMessage, "(say %s)", message);
#endif
}
