#include "GYR.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor GYR() vytvori podtriedy, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje GYR_perceptor.
 */

GYR::GYR()
{
	n = new N();
	rt = new Rt();
}

/**
 * Metoda decompose() rozlozi na prvky podtried cast prijatej spravy, ktora obsahuje GYR_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje GYR_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje GYR_perceptor.
 */

int GYR::decompose(char *receivingMessage)
{
	int i = 5;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			char *receivingMessage3 = receivingMessage2 + 1;
			if (strncmp(receivingMessage3, "n ", 2) == 0)
			{
				i += n->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "rt ", 3) == 0)
			{
				i += rt->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"GYR\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getN() vrati ukazovatel na n perceptor.
 * @return Ukazovatel na n perceptor.
 */

N *GYR::getN()
{
	return n;
}

/**
 * Metoda getRt() vrati ukazovatel na rt perceptor.
 * @return Ukazovatel na rt perceptor.
 */

Rt *GYR::getRt()
{
	return rt;
}

/**
 * Desruktor ~GYR() zrusi podtriedy, ktore boli potrebne na rozlozenie casti prijatej spravy, ktora obsahovala GYR_perceptor.
 */

GYR::~GYR()
{
	delete rt;
	delete n;
}
