#include "HJ.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor HJ() vytvori podtriedy, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje HJ_perceptor.
 */

HJ::HJ()
{
	n = new N();
	ax = new Ax();
}

/**
 * Metoda decompose() rozlozi na prvky podtried cast prijatej spravy, ktora obsahuje HJ_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje HJ_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje HJ_perceptor.
 */

int HJ::decompose(char *receivingMessage)
{
	int i = 4;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			char *receivingMessage3 = receivingMessage2 + 1;
			if (strncmp(receivingMessage3, "n ", 2) == 0)
			{
				i += n->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "ax ", 3) == 0)
			{
				i += ax->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"HJ\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getN() vrati ukazovatel na n perceptor.
 * @return Ukazovatel na n perceptor.
 */

N *HJ::getN()
{
	return n;
}

/**
 * Metoda getAx() vrati ukazovatel na ax perceptor.
 * @return Ukazovatel na ax perceptor.
 */

Ax *HJ::getAx()
{
	return ax;
}

/**
 * Desruktor ~HJ() zrusi podtriedy, ktore boli potrebne na rozlozenie casti prijatej spravy, ktora obsahovala HJ_perceptor.
 */

HJ::~HJ()
{
	delete ax;
	delete n;
}
