#include "Hear.h"
#include <stdio.h>
#include <string.h>

/**
 * Konstruktor Hear() inicializuje prvky, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje hear perceptor.
 */

Hear::Hear()
{
	time = 0;
	direction[0] = '\0';
	message[0] = '\0';
}

/**
 * Metoda decompose() rozlozi na prvky cast prijatej spravy, ktora obsahuje hear perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje hear perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje hear perceptor.
 */

int Hear::decompose(char *receivingMessage)
{
	int j;
	for (j = 9; receivingMessage[j] != ' '; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + 6, "%f", &time);
#else
	sscanf(receivingMessage + 6, "%f", &time);
#endif
	int i = j + 1;
	for (j = i; receivingMessage[j] != ' '; j ++)
	{
	}
	int length = j - i;
	memcpy(direction, receivingMessage + i, length);
	direction[length] = '\0';
	i = j + 1;
	for (j = i; receivingMessage[j] != ')'; j ++)
	{
	}
	length = j - i;
	memcpy(message, receivingMessage + i, length);
	message[length] = '\0';
	return j + 1;
}

/**
 * Metoda getTime() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje hear perceptor.
 * @return Simulacny cas, v ktorom agent pocuje spravu.
 */

float Hear::getTime()
{
	return time;
}

/**
 * Metoda getDirection() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje hear perceptor.
 * @return Smer pocutia spravy.
 */

char *Hear::getDirection()
{
	return direction;
}

/**
 * Metoda getMessage() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje hear perceptor.
 * @return Pocuta sprava.
 */

char *Hear::getMessage()
{
	return message;
}
