#include "See.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor See() vytvori podtriedy, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje See_perceptor.
 */

See::See()
{
	pCount = 0;
	p = new P[21]();
	f1lCount = 0;
	f1l = new F1L[1]();
	f1rCount = 0;
	f1r = new F1R[1]();
	f2lCount = 0;
	f2l = new F2L[1]();
	f2rCount = 0;
	f2r = new F2R[1]();
	g1lCount = 0;
	g1l = new G1L[1]();
	g1rCount = 0;
	g1r = new G1R[1]();
	g2lCount = 0;
	g2l = new G2L[1]();
	g2rCount = 0;
	g2r = new G2R[1]();
	bCount = 0;
	b = new B[1]();
}

/**
 * Metoda decompose() rozlozi na prvky podtried cast prijatej spravy, ktora obsahuje See_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje See_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje See_perceptor.
 */

int See::decompose(char *receivingMessage)
{
	pCount = 0;
	f1lCount = 0;
	f1rCount = 0;
	f2lCount = 0;
	f2rCount = 0;
	g1lCount = 0;
	g1rCount = 0;
	g2lCount = 0;
	g2rCount = 0;
	bCount = 0;
	int i = 5;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			char *receivingMessage3 = receivingMessage2 + 1;
			if (strncmp(receivingMessage3, "P ", 2) == 0)
			{
				i += p[pCount].decompose(receivingMessage2);
				pCount ++;
			}
			else if (strncmp(receivingMessage3, "F1L ", 4) == 0)
			{
				i += f1l[f1lCount].decompose(receivingMessage2);
				f1lCount ++;
			}
			else if (strncmp(receivingMessage3, "F1R ", 4) == 0)
			{
				i += f1r[f1rCount].decompose(receivingMessage2);
				f1rCount ++;
			}
			else if (strncmp(receivingMessage3, "F2L ", 4) == 0)
			{
				i += f2l[f2lCount].decompose(receivingMessage2);
				f2lCount ++;
			}
			else if (strncmp(receivingMessage3, "F2R ", 4) == 0)
			{
				i += f2r[f2rCount].decompose(receivingMessage2);
				f2rCount ++;
			}
			else if (strncmp(receivingMessage3, "G1L ", 4) == 0)
			{
				i += g1l[g1lCount].decompose(receivingMessage2);
				g1lCount ++;
			}
			else if (strncmp(receivingMessage3, "G1R ", 4) == 0)
			{
				i += g1r[g1rCount].decompose(receivingMessage2);
				g1rCount ++;
			}
			else if (strncmp(receivingMessage3, "G2L ", 4) == 0)
			{
				i += g2l[g2lCount].decompose(receivingMessage2);
				g2lCount ++;
			}
			else if (strncmp(receivingMessage3, "G2R ", 4) == 0)
			{
				i += g2r[g2rCount].decompose(receivingMessage2);
				g2rCount ++;
			}
			else if (strncmp(receivingMessage3, "B ", 2) == 0)
			{
				i += b[bCount].decompose(receivingMessage2);
				bCount ++;
			}
			/* Chyba servera */
			else if (strncmp(receivingMessage3, " ", 1) == 0)
			{
				int j = 2;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"See\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getPCount() vrati pocet P_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet P_perceptorov.
 */

int See::getPCount()
{
	return pCount;
}

/**
 * Metoda getP() vrati ukazovatel na pozadovany P_perceptor.
 * @param index - Cislo pozadovaneho P_perceptoru.
 * @return Ukazovatel na pozadovany P_perceptor.
 */

P *See::getP(int index)
{
	return &p[index];
}

/**
 * Metoda getF1LCount() vrati pocet F1L_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet F1L_perceptorov.
 */

int See::getF1LCount()
{
	return f1lCount;
}

/**
 * Metoda getF1L() vrati ukazovatel na pozadovany F1L_perceptor.
 * @param index - Cislo pozadovaneho F1L_perceptoru.
 * @return Ukazovatel na pozadovany F1L_perceptor.
 */

F1L *See::getF1L(int index)
{
	return &f1l[index];
}

/**
 * Metoda getF1RCount() vrati pocet F1R_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet F1R_perceptorov.
 */

int See::getF1RCount()
{
	return f1rCount;
}

/**
 * Metoda getF1R() vrati ukazovatel na pozadovany F1R_perceptor.
 * @param index - Cislo pozadovaneho F1R_perceptoru.
 * @return Ukazovatel na pozadovany F1R_perceptor.
 */

F1R *See::getF1R(int index)
{
	return &f1r[index];
}

/**
 * Metoda getF2LCount() vrati pocet F2L_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet F2L_perceptorov.
 */

int See::getF2LCount()
{
	return f2lCount;
}

/**
 * Metoda getF2L() vrati ukazovatel na pozadovany F2L_perceptor.
 * @param index - Cislo pozadovaneho F2L_perceptoru.
 * @return Ukazovatel na pozadovany F2L_perceptor.
 */

F2L *See::getF2L(int index)
{
	return &f2l[index];
}

/**
 * Metoda getF2RCount() vrati pocet F2R_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet F2R_perceptorov.
 */

int See::getF2RCount()
{
	return f2rCount;
}

/**
 * Metoda getF2R() vrati ukazovatel na pozadovany F2R_perceptor.
 * @param index - Cislo pozadovaneho F2R_perceptoru.
 * @return Ukazovatel na pozadovany F2R_perceptor.
 */

F2R *See::getF2R(int index)
{
	return &f2r[index];
}

/**
 * Metoda getG1LCount() vrati pocet G1L_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet G1L_perceptorov.
 */

int See::getG1LCount()
{
	return g1lCount;
}

/**
 * Metoda getG1L() vrati ukazovatel na pozadovany G1L_perceptor.
 * @param index - Cislo pozadovaneho G1L_perceptoru.
 * @return Ukazovatel na pozadovany G1L_perceptor.
 */

G1L *See::getG1L(int index)
{
	return &g1l[index];
}

/**
 * Metoda getG1RCount() vrati pocet G1R_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet G1R_perceptorov.
 */

int See::getG1RCount()
{
	return g1rCount;
}

/**
 * Metoda getG1R() vrati ukazovatel na pozadovany G1R_perceptor.
 * @param index - Cislo pozadovaneho G1R_perceptoru.
 * @return Ukazovatel na pozadovany G1R_perceptor.
 */

G1R *See::getG1R(int index)
{
	return &g1r[index];
}

/**
 * Metoda getG2LCount() vrati pocet G2L_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet G2L_perceptorov.
 */

int See::getG2LCount()
{
	return g2lCount;
}

/**
 * Metoda getG2L() vrati ukazovatel na pozadovany G2L_perceptor.
 * @param index - Cislo pozadovaneho G2L_perceptoru.
 * @return Ukazovatel na pozadovany G2L_perceptor.
 */

G2L *See::getG2L(int index)
{
	return &g2l[index];
}

/**
 * Metoda getG2RCount() vrati pocet G2R_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet G1R_perceptorov.
 */

int See::getG2RCount()
{
	return g2rCount;
}

/**
 * Metoda getG2R() vrati ukazovatel na pozadovany G2R_perceptor.
 * @param index - Cislo pozadovaneho G2R_perceptoru.
 * @return Ukazovatel na pozadovany G2R_perceptor.
 */

G2R *See::getG2R(int index)
{
	return &g2r[index];
}

/**
 * Metoda getBCount() vrati pocet B_perceptorov, ktore boli obsiahnute v prijatej sprave.
 * @return Pocet B_perceptorov.
 */

int See::getBCount()
{
	return bCount;
}

/**
 * Metoda getB() vrati ukazovatel na pozadovany B_perceptor.
 * @param index - Cislo pozadovaneho B_perceptoru.
 * @return Ukazovatel na pozadovany B_perceptor.
 */

B *See::getB(int index)
{
	return &b[index];
}

/**
 * Desruktor ~See() zrusi podtriedy, ktore boli potrebne na rozlozenie casti prijatej spravy, ktora obsahovala See_perceptor.
 */

See::~See()
{
	delete[] b;
	delete[] f2r;
	delete[] f2l;
	delete[] f1r;
	delete[] f1l;
	delete[] g2r;
	delete[] g2l;
	delete[] g1r;
	delete[] g1l;
	delete[] p;
}
