#include "B.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor B() vytvori podtriedu, ktora bude potrebna na rozlozenie casti prijatej spravy, ktora obsahuje B_perceptor.
 */

B::B()
{
	pol = new Pol();
}

/**
 * Metoda decompose() rozlozi na prvky podtriedy cast prijatej spravy, ktora obsahuje B_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje B_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje B_perceptor.
 */

int B::decompose(char *receivingMessage)
{
	int i = 3;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			if (strncmp(receivingMessage2 + 1, "pol ", 4) == 0)
			{
				i += pol->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"See->B\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getPol() vrati ukazovatel na pol perceptor.
 * @return Ukazovatel na pol perceptor.
 */

Pol *B::getPol()
{
	return pol;
}

/**
 * Desruktor ~B() zrusi podtriedu, ktora bola potrebna na rozlozenie casti prijatej spravy, ktora obsahovala B_perceptor.
 */

B::~B()
{
	delete pol;
}
