#include "P.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor P() vytvori podtriedy, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje P_perceptor.
 */

P::P()
{
	team2 = new Team2();
	id = new Id();
	pol = new Pol();
}

/**
 * Metoda decompose() rozlozi na prvky podtried cast prijatej spravy, ktora obsahuje P_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje P_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje P_perceptor.
 */

int P::decompose(char *receivingMessage)
{
	int i = 3;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			char *receivingMessage3 = receivingMessage2 + 1;
			if (strncmp(receivingMessage3, "team ", 5) == 0)
			{
				i += team2->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "id ", 3) == 0)
			{
				i += id->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "pol ", 4) == 0)
			{
				i += pol->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"See->P\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getTeam() vrati ukazovatel na team perceptor.
 * @return Ukazovatel na team perceptor.
 */

Team2 *P::getTeam()
{
	return team2;
}

/**
 * Metoda getId() vrati ukazovatel na id perceptor.
 * @return Ukazovatel na id perceptor.
 */

Id *P::getId()
{
	return id;
}

/**
 * Metoda getPol() vrati ukazovatel na pol perceptor.
 * @return Ukazovatel na pol perceptor.
 */

Pol *P::getPol()
{
	return pol;
}

/**
 * Desruktor ~P() zrusi podtriedy, ktore boli potrebne na rozlozenie casti prijatej spravy, ktora obsahovala P_perceptor.
 */

P::~P()
{
	delete pol;
	delete id;
	delete team2;
}
