#include "Pol.h"
#include <stdio.h>

/**
 * Konstruktor Pol() inicializuje prvky, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje pol perceptor.
 */

Pol::Pol()
{
	distance = 0;
	angle1 = 0;
	angle2 = 0;
}

/**
 * Metoda decompose() rozlozi na prvky cast prijatej spravy, ktora obsahuje pol perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje pol perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje pol perceptor.
 */

int Pol::decompose(char *receivingMessage)
{
	int j;
	for (j = 8; receivingMessage[j] != ' '; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + 5, "%f", &distance);
#else
	sscanf(receivingMessage + 5, "%f", &distance);
#endif
	int i = j + 1;
	for (j = i + 3; receivingMessage[j] != ' '; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + i, "%f", &angle1);
#else
	sscanf(receivingMessage + i, "%f", &angle1);
#endif
	i = j + 1;
	for (j = i + 3; receivingMessage[j] != ')'; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + i, "%f", &angle2);
#else
	sscanf(receivingMessage + i, "%f", &angle2);
#endif
	return j + 1;
}

/**
 * Metoda getDistance() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje pol perceptor.
 * @return Vzdialenost, v ktorej agent nieco vidi.
 */

float Pol::getDistance()
{
	return distance;
}

/**
 * Metoda getAngle1() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje pol perceptor.
 * @return 1. uhol, pod ktorym agent nieco vidi.
 */

float Pol::getAngle1()
{
	return angle1;
}

/**
 * Metoda getAngle2() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje pol perceptor.
 * @return 2. uhol, pod ktorym agent nieco vidi.
 */

float Pol::getAngle2()
{
	return angle2;
}
